Index: issm/trunk/src/m/classes/public/process_solve_options.m
===================================================================
--- issm/trunk/src/m/classes/public/process_solve_options.m	(revision 465)
+++ issm/trunk/src/m/classes/public/process_solve_options.m	(revision 465)
@@ -0,0 +1,79 @@
+function outoptions=process_solve_options(options)
+%DEFAULT_SOLVE_OPTIONS - set up default options for solve phase
+%
+%   Usage:
+%      options=process_solve_options(options)
+%
+%   See also: SOLVE,RECOVER_SOLVE_OPTIONS
+
+
+
+
+%analysis_type: check on this option, error out otherwise
+found=0;
+for i=1:size(options,1),
+	if strcmpi(options{i,1},'analysis_type'),
+		analysis_type=options{i,2};
+		found=1;
+	end
+end
+if ~found,
+	error('recover_solve_options error message: no ''analysis_type'' was provided');
+end
+
+%package: is there one? check to ''cielo''
+found=0;
+for i=1:size(options,1),
+	if strcmpi(options{i,1},'package'),
+		package=options{i,2};
+		found=1;
+	end
+end
+if ~found,
+	disp('recover_solve_options info message: no ''package'' was provided, defaulting to ''cielo''');
+	options(end+1,:)={'package' 'cielo'};
+	package='cielo';
+end
+
+if ~ischar(package), 
+	error(['process_solve_options error message: package ' package ' not supported yet']);
+end
+
+%sub_analysis_type: check on it, not mandatory
+found=0;
+for i=1:size(options,1),
+	if strcmpi(options{i,1},'sub_analysis_type'),
+		sub_analysis_type=options{i,2};
+		found=1;
+	end
+end
+if ~found,
+	sub_analysis_type='';
+end
+
+%check solution type is supported
+if ~(strcmpi(analysis_type,'control') |  ...
+	strcmpi(analysis_type,'diagnostic') |  ...
+	strcmpi(analysis_type,'prognostic') |  ...
+	strcmpi(analysis_type,'thermal') |  ...
+	strcmpi(analysis_type,'mesh') |  ...
+	strcmpi(analysis_type,'mesh2grid') |  ...
+	strcmpi(analysis_type,'qmu') |  ...
+	strcmpi(analysis_type,'transient') ),
+	error(['process_solve_options error message: analysis_type ' analysis_type ' not supported yet!']);
+end
+
+if ~(strcmpi(sub_analysis_type,'') |  ...
+	strcmpi(sub_analysis_type,'steady_state') |  ...
+	strcmpi(sub_analysis_type,'horiz') |  ...
+	strcmpi(sub_analysis_type,'vert') |  ...
+	strcmpi(sub_analysis_type,'transient') ),
+	error(['process_solve_options error message: sub_analysis_type ' sub_analysis_type ' not supported yet!']);
+end
+
+
+
+%setup final options structure
+outoptions.analysis_type=analysis_type;
+outoptions.package=package;
+outoptions.sub_analysis_type=sub_analysis_type;
Index: issm/trunk/src/m/classes/public/recover_solve_options.m
===================================================================
--- issm/trunk/src/m/classes/public/recover_solve_options.m	(revision 465)
+++ issm/trunk/src/m/classes/public/recover_solve_options.m	(revision 465)
@@ -0,0 +1,22 @@
+function options=recover_solve_options(md,varargin)
+%RECOVER_SOLVE_OPTIONS - recover solution options
+%
+%   Usage:
+%      options=recover_solve_options(md,varargin);
+%
+%   See also: SOLVE
+
+%initialize options.
+options=cell(0,2);
+
+%make sure length(varargin) is even, ie options come in pairs.
+if mod(length(varargin),2),
+	error('recover_solve_options error message: an even number of options is necessary');
+end
+
+%go through varargin, extract options 
+for i=1:length(varargin)/2,
+
+	options(end+1,:)={varargin{2*i-1} varargin{2*i}};
+
+end
Index: issm/trunk/src/m/classes/public/solve.m
===================================================================
--- issm/trunk/src/m/classes/public/solve.m	(revision 464)
+++ issm/trunk/src/m/classes/public/solve.m	(revision 465)
@@ -1,64 +1,47 @@
-function md=solve(md,solutiontype,varargin)
+function md=solve(md,varargin)
 %SOLVE - apply solution sequence for this model
 %
-%   solutiontype is 'diagnostic','prognostic','transient','thermalsteady','thermaltransient','parameters' or 'control'
-%   and varargin is an optional package name ('cielo', 'ice' or 'macayeal')
-%
 %   Usage:
-%       md=solve(md,solutiontype,varargin)
+%       md=solve(md,varargin)
+%       where varargin is a lit of paired arguments. 
+%       arguments can be: 'analysis_type': 'diagnostic','thermal','prognostic','transient'
+%       arguments can be: 'sub_analysis_type': 'transient',''
+%       arguments can be: 'package': 'macayeal','ice','cielo'
 %
 %   Examples:
-%      md=solve(md,'diagnostic','macayeal');
-%      md=solve(md,'control','cielo');
+%      md=solve(md,'analysis_type','diagnostic','package','cielo');
+%      md=solve(md,'analysis_type','control','package','ice');
+%      md=solve(md,'analysis_type','thermal','sub_analysis_type','transient','package','ice');
+%      md=solve(md,'analysis_type','thermal','sub_analysis_type','','package','cielo');
 
 %some checks on list of arguments
-
 global ISSM_DIR
 
-solutions={'mesh2grid','mesh','thermaltransient','thermalsteady','qmu','diagnostic','diagnostic_horiz','prognostic','transient','parameters','control'};
-found=0;
-for i=1:length(solutions),
-	if strcmpi(solutiontype,solutions{i}),
-		found=1;
-		break;
-	end
-end
+%recover options
+options=recover_solve_options(md,varargin{:});
 
-if found==0,
-	error(['solve error message: solution type ' solutiontype ' not supported yet!']);
-end
+%add default options
+options=process_solve_options(options);
 
-%we are good with this solutiontype, put in the analysis_type field of md: 
-md.analysis_type=solutiontype;
-
-%Recover type of package being used: 
-if nargin==2,
-	package='Ice';
-else
-	package=varargin{1};
-end
-
-if ~ischar(package), 
-	error('Package specified in varargin can only be ''ice'', or ''cielo''');
-end
-
-if ~(strcmpi(package,'ice') || strcmpi(package,'cielo') || strcmpi(package,'macayeal'))
-	error('Package specified in varargin can only be ''ice'', ''macayeal'', or ''cielo''');
-end
+%recover some fields
+md.analysis_type=options.analysis_type;
+md.sub_analysis_type=options.sub_analysis_type;
+package=options.package;
 
 %Use package to set solution namespace
 usenamespace(package);
 
-if ~ismodelselfconsistent(md,solutiontype,package),
-		error(' '); %previous error messages should explain what is going on.
+if ~ismodelselfconsistent(md,package),
+	error(' '); %previous error messages should explain what is going on.
 end
 
 displaystring(md.debug,'\n%s\n','launching solution sequence');
 
+
 %If running in parallel, we have a different way of launching the solution
-%sequences.
-if ~strcmpi(solutiontype,'qmu'),
+%sequences. qmu is the only solution sequence that cannot run in parallel
+if ~strcmpi(md.analysis_type,'qmu'),
 	if ~strcmpi(md.cluster,'none'),
-		md=solveparallel(md,solutiontype,package);
+		md=solveparallel(md)
 		return;
 	end
@@ -66,30 +49,27 @@
 
 %Lauch correct solution sequence
-if strcmpi(solutiontype,'diagnostic'),
+if strcmpi(md.analysis_type,'diagnostic'),
 	md=diagnostic(md);
 
-elseif strcmpi(solutiontype,'mesh'),
+elseif strcmpi(md.analysis_type,'mesh'),
 	md=mesh(md);
 
-elseif strcmpi(solutiontype,'transient'),
+elseif strcmpi(md.analysis_type,'transient'),
 	md=transient(md);
 
-elseif strcmpi(solutiontype,'qmu'),
+elseif strcmpi(md.analysis_type,'qmu'),
 	md=qmu(md,package);
 
-elseif strcmpi(solutiontype,'parameters'),
-	md=parameters(md);;
-
-elseif strcmpi(solutiontype,'mesh2grid'),
+elseif strcmpi(md.analysis_type,'mesh2grid'),
 	md=mesh2grid(md);;
 
-elseif strcmpi(solutiontype,'prognostic'),
+elseif strcmpi(md.analysis_type,'prognostic'),
 	md=prognostic(md);;
 
-elseif strcmpi(solutiontype,'control'),
+elseif strcmpi(md.analysis_type,'control'),
 	md=control(md);
 
-elseif strcmpi(solutiontype,'thermalsteady') | strcmpi(solutiontype,'thermaltransient'),
-	md=thermal(md,solutiontype);
+elseif strcmpi(md.analysis_type,'thermal'),
+	md=thermal(md);
 else
 	error('solution type not supported for this model configuration.');
@@ -98,5 +78,5 @@
 %Check result is consistent
 displaystring(md.debug,'%s\n','checking result consistency');
-if ~isresultconsistent(md,solutiontype),
+if ~isresultconsistent(md),
 	disp('!! results not consistent correct the model !!') %it would be very cruel to put an error, it would kill the computed results (even if not consistent...)
 end
@@ -110,5 +90,5 @@
 function solveusage();
 disp(' ');
-disp('   Solve usage: md=solve(md,solutiontype,package)');
-disp('         solutiontype can be ''diagnostic'',''transient'', ''thermalsteady'',''thermaltransient'',''parameters'',''mesh2grid''  or ''control''');
+disp('   Solve usage: md=solve(md,md.analysis_type,package)');
+disp('         md.analysis_type can be ''diagnostic'',''transient'', ''thermal'',''thermaltransient'',''parameters'',''mesh2grid''  or ''control''');
 disp('         package is either ''cielo'' or ''ice''');
Index: issm/trunk/src/m/classes/public/solveparallel.m
===================================================================
--- issm/trunk/src/m/classes/public/solveparallel.m	(revision 464)
+++ issm/trunk/src/m/classes/public/solveparallel.m	(revision 465)
@@ -1,22 +1,7 @@
-function md=solveparallel(md,solutiontype,varargin)
+function md=solveparallel(md)
 %SOLVEPARALLEL - solution sequence using a cluster in parallel mode
 %
 %   Usage:
-%      md=solveparallel(md,solutiontype,varargin)
-
-%Recover type of package being used: 
-if nargin==2,
-	package='Ice';
-else
-	package=varargin{1};
-end
-
-if ~ischar(package), 
-	error('Package specified in varargin can only be ''ice'', or ''cielo''');
-end
-
-if ~(strcmpi(package,'ice') || strcmpi(package,'cielo') || strcmpi(package,'macayeal'))
-	error('Package specified in varargin can only be ''ice'', ''macayeal'', or ''cielo''');
-end
+%      md=solveparallel(md);
 
 %Get cluster.rc location
@@ -27,8 +12,8 @@
 
 %Marshall model data into a binary file.
-marshall(md,solutiontype,package);
+marshall(md);
 
 %Now, we need to build the queuing script, used by the cluster to launch the job.
-BuildQueueingScript(md,solutiontype,executionpath,codepath);
+BuildQueueingScript(md,executionpath,codepath);
 
 %Now, launch the queueing script
@@ -40,5 +25,5 @@
 	waitonlock([executionpath '/' md.name '.lock']);
 	%load results
-	md=loadresultsfromcluster(md,solutiontype);
+	md=loadresultsfromcluster(md);
 else
 	return;
Index: issm/trunk/src/m/solutions/cielo/GradJCompute.m
===================================================================
--- issm/trunk/src/m/solutions/cielo/GradJCompute.m	(revision 464)
+++ issm/trunk/src/m/solutions/cielo/GradJCompute.m	(revision 465)
@@ -1,3 +1,3 @@
-function [u_g grad_g]=GradJCompute(m,inputs, u_g_obs,analysis_type);
+function [u_g grad_g]=GradJCompute(m,inputs, u_g_obs,analysis_type,sub_analysis_type);
 
 %Recover solution for this stiffness and right hand side: 
@@ -5,5 +5,5 @@
 	disp('         computing velocities...')
 end
-[u_g K_ff0 K_fs0 ]=diagnostic_core_nonlinear(m,inputs,analysis_type);
+[u_g K_ff0 K_fs0 ]=diagnostic_core_nonlinear(m,inputs,analysis_type,sub_analysis_type);
 
 %Buid Du, difference between observed velocity and model velocity.
@@ -11,5 +11,5 @@
 	disp('         computing Du...')
 end
-[Du_g]=Du(m.elements,m.nodes,m.loads,m.materials,m.parameters, u_g,u_g_obs,inputs);
+[Du_g]=Du(m.elements,m.nodes,m.loads,m.materials,m.parameters, u_g,u_g_obs,inputs,analysis_type,sub_analysis_type);
 
 %Reduce adjoint load from g-set to f-set
@@ -26,3 +26,3 @@
 
 %Compute gradJ 
-grad_g=Gradj(m.elements,m.nodes,m.loads,m.materials,m.parameters, u_g, lambda_g,inputs);
+grad_g=Gradj(m.elements,m.nodes,m.loads,m.materials,m.parameters, u_g, lambda_g,inputs,analysis_type,sub_analysis_type);
Index: issm/trunk/src/m/solutions/cielo/control.m
===================================================================
--- issm/trunk/src/m/solutions/cielo/control.m	(revision 464)
+++ issm/trunk/src/m/solutions/cielo/control.m	(revision 465)
@@ -6,4 +6,5 @@
 	%Build all models requested for control simulation
 	md.analysis_type='control';
+	md.sub_analysis_type='';
 	m=CreateFemModel(md); 
 
@@ -40,5 +41,5 @@
 
 		disp('      computing gradJ...');
-		[u_g c(n).grad_g]=GradJCompute(m,inputs,u_g_obs,md.analysis_type);
+		[u_g c(n).grad_g]=GradJCompute(m,inputs,u_g_obs,md.analysis_type,md.sub_analysis_type);
 		inputs=add(inputs,'velocity',u_g,'doublevec',2,m.parameters.numberofnodes);
 		disp('      done.');
@@ -58,5 +59,5 @@
 		
 		disp('      optimizing along gradient direction...'); 
-		[search_scalar c(n).J]=ControlOptimization('objectivefunctionC',0,1,options,m,inputs,p_g,u_g_obs,c(n).grad_g,n,md.analysis_type);
+		[search_scalar c(n).J]=ControlOptimization('objectivefunctionC',0,1,options,m,inputs,p_g,u_g_obs,c(n).grad_g,n,md.analysis_type,md.sub_analysis_type);
 		disp('      done.');
 
@@ -76,5 +77,5 @@
 		%some temporary saving 
 		if(mod(n,5)==0),
-			solution=controlfinalsol(c,m,p_g,inputs,md.analysis_type);
+			solution=controlfinalsol(c,m,p_g,inputs,md.analysis_type,md.sub_analysis_type);
 			save temporary_control_results solution
 		end
@@ -85,5 +86,5 @@
 	%Create final solution
 	disp('      preparing final velocity solution...');
-	solution=controlfinalsol(c,m,p_g,inputs,md.analysis_type);
+	solution=controlfinalsol(c,m,p_g,inputs,md.analysis_type,md.sub_analysis_type);
 	disp('      done.');
 	
Index: issm/trunk/src/m/solutions/cielo/controlfinalsol.m
===================================================================
--- issm/trunk/src/m/solutions/cielo/controlfinalsol.m	(revision 464)
+++ issm/trunk/src/m/solutions/cielo/controlfinalsol.m	(revision 465)
@@ -1,7 +1,7 @@
-function solution=controlfinalsol(c,m,p_g,inputs,analysis_type);
+function solution=controlfinalsol(c,m,p_g,inputs,analysis_type,sub_analysis_type);
 
 %From parameters, build inputs for icediagnostic_core, using the final parameters
 inputs=add(inputs,m.parameters.control_type,p_g,'doublevec',2,m.parameters.numberofnodes);
-u_g=diagnostic_core_nonlinear(m,inputs,analysis_type);
+u_g=diagnostic_core_nonlinear(m,inputs,analysis_type,sub_analysis_type);
 
 %Build partitioning vectors to recover solution
Index: issm/trunk/src/m/solutions/cielo/diagnostic.m
===================================================================
--- issm/trunk/src/m/solutions/cielo/diagnostic.m	(revision 464)
+++ issm/trunk/src/m/solutions/cielo/diagnostic.m	(revision 465)
@@ -10,17 +10,17 @@
 	%Build all models requested for diagnostic simulation
 	displaystring(md.debug,'%s',['reading diagnostic horiz model data']);
-	md.analysis_type='diagnostic_horiz'; m_dh=CreateFemModel(md);
+	md.analysis_type='diagnostic'; md.sub_analysis_type='horiz'; m_dh=CreateFemModel(md);
 	
 	displaystring(md.debug,'\n%s',['reading diagnostic vert model data']);
-	md.analysis_type='diagnostic_vert'; m_dv=CreateFemModel(md);
+	md.analysis_type='diagnostic'; md.sub_analysis_type='vert'; m_dv=CreateFemModel(md);
 	
 	displaystring(md.debug,'\n%s',['reading diagnostic stokes model data']);
-	md.analysis_type='diagnostic_stokes'; m_ds=CreateFemModel(md);
+	md.analysis_type='diagnostic'; md.sub_analysis_type='stokes'; m_ds=CreateFemModel(md);
 
 	displaystring(md.debug,'\n%s',['reading diagnostic hutter model data']);
-	md.analysis_type='diagnostic_hutter'; m_dhu=CreateFemModel(md);
+	md.analysis_type='diagnostic'; md.sub_analysis_type='hutter'; m_dhu=CreateFemModel(md);
 	
 	displaystring(md.debug,'\n%s',['reading surface and bed slope computation model data']);
-	md.analysis_type='slope_compute'; m_sl=CreateFemModel(md);
+	md.analysis_type='slope_compute'; md.sub_analysis_type=''; m_sl=CreateFemModel(md);
 	
 	% figure out number of dof: just for information purposes.
Index: issm/trunk/src/m/solutions/cielo/diagnostic_core.m
===================================================================
--- issm/trunk/src/m/solutions/cielo/diagnostic_core.m	(revision 464)
+++ issm/trunk/src/m/solutions/cielo/diagnostic_core.m	(revision 465)
@@ -16,6 +16,6 @@
 
 	displaystring(debug,'\n%s',['computing surface slope (x and y derivatives)...']);
-	slopex=diagnostic_core_linear(m_sl,inputs,'surface_slope_compute_x');
-	slopey=diagnostic_core_linear(m_sl,inputs,'surface_slope_compute_y');
+	slopex=diagnostic_core_linear(m_sl,inputs,'slope_compute','surfacex');
+	slopey=diagnostic_core_linear(m_sl,inputs,'slope_compute','surfacey');
 
 	if dim==3,
@@ -30,5 +30,5 @@
 
 	displaystring(debug,'\n%s',['computing hutter velocities...']);
-	u_g=diagnostic_core_linear(m_dhu,inputs,'diagnostic_hutter');
+	u_g=diagnostic_core_linear(m_dhu,inputs,'diagnostic','hutter');
 
 	displaystring(debug,'\n%s',['computing pressure according to MacAyeal...']);
@@ -46,5 +46,5 @@
 
 	displaystring(debug,'\n%s',['computing horizontal velocities...']);
-	u_g=diagnostic_core_nonlinear(m_dh,inputs,'diagnostic_horiz');
+	u_g=diagnostic_core_nonlinear(m_dh,inputs,'diagnostic','horiz');
 
 	displaystring(debug,'\n%s',['computing pressure according to MacAyeal...']);
@@ -59,5 +59,5 @@
 	displaystring(debug,'\n%s',['computing vertical velocities...']);
 	inputs=add(inputs,'velocity',u_g_horiz,'doublevec',m_dh.parameters.numberofdofspernode,m_dh.parameters.numberofnodes);
-	u_g_vert=diagnostic_core_linear(m_dv,inputs,'diagnostic_vert');
+	u_g_vert=diagnostic_core_linear(m_dv,inputs,'diagnostic','vert');
 
 	displaystring(debug,'\n%s',['combining horizontal and vertical velocities...']);
@@ -75,6 +75,6 @@
 
 		displaystring(debug,'\n%s',['computing bed slope (x and y derivatives)...']);
-		slopex=diagnostic_core_linear(m_sl,inputs,'bed_slope_compute_x');
-		slopey=diagnostic_core_linear(m_sl,inputs,'bed_slope_compute_y');
+		slopex=diagnostic_core_linear(m_sl,inputs,'slope_compute','bedx');
+		slopey=diagnostic_core_linear(m_sl,inputs,'slope_compute','bedy');
 		slopex=SlopeExtrude(m_sl.elements,m_sl.nodes,m_sl.loads,m_sl.materials,slopex);
 		slopey=SlopeExtrude(m_sl.elements,m_sl.nodes,m_sl.loads,m_sl.materials,slopey);
@@ -95,5 +95,5 @@
 
 		displaystring(debug,'\n%s',['computing stokes velocities and pressure ...']);
-		u_g=diagnostic_core_nonlinear(m_ds,inputs,'diagnostic_stokes');
+		u_g=diagnostic_core_nonlinear(m_ds,inputs,'diagnostic','stokes');
 	
 		%"decondition" pressure
Index: issm/trunk/src/m/solutions/cielo/diagnostic_core_nonlinear.m
===================================================================
--- issm/trunk/src/m/solutions/cielo/diagnostic_core_nonlinear.m	(revision 464)
+++ issm/trunk/src/m/solutions/cielo/diagnostic_core_nonlinear.m	(revision 465)
@@ -1,3 +1,3 @@
-function [u_g varargout]=diagnostic_core_nonlinear(m,inputs,analysis_type)
+function [u_g varargout]=diagnostic_core_nonlinear(m,inputs,analysis_type,sub_analysis_type)
 %INPUT function [ru_g varargout]=cielodiagnostic_core_nonlinear(m,inputs)
 	
@@ -30,8 +30,8 @@
 		
 		%system matrices 
-		[K_gg_nopenalty , p_g_nopenalty]=SystemMatrices(m.elements,m.nodes,loads,m.materials,m.parameters,inputs,analysis_type);
+		[K_gg_nopenalty , p_g_nopenalty]=SystemMatrices(m.elements,m.nodes,loads,m.materials,m.parameters,inputs,analysis_type,sub_analysis_type);
 		
 		%penalties
-		[K_gg , p_g]=PenaltySystemMatrices(K_gg_nopenalty,p_g_nopenalty,m.elements,m.nodes,loads,m.materials,m.parameters,inputs,analysis_type);
+		[K_gg , p_g]=PenaltySystemMatrices(K_gg_nopenalty,p_g_nopenalty,m.elements,m.nodes,loads,m.materials,m.parameters,inputs,analysis_type,sub_analysis_type);
 
 
@@ -60,5 +60,5 @@
 	
 		%penalty constraints
-		[loads,constraints_converged,num_unstable_constraints] =PenaltyConstraints( m.elements,m.nodes, loads, m.materials,m.parameters,inputs);
+		[loads,constraints_converged,num_unstable_constraints] =PenaltyConstraints( m.elements,m.nodes, loads, m.materials,m.parameters,inputs,analysis_type,sub_analysis_type);
 
 	%   Figure out if convergence is reached.
@@ -107,5 +107,5 @@
 		inputs=add(inputs,'velocity',soln(count).u_g,'doublevec',m.parameters.numberofdofspernode,m.parameters.numberofnodes);
 		m.parameters.kflag=1; m.parameters.pflag=0; 
-		[K_gg, p_g]=SystemMatrices(m.elements,m.nodes,loads,m.materials,m.parameters,inputs,analysis_type);
+		[K_gg, p_g]=SystemMatrices(m.elements,m.nodes,loads,m.materials,m.parameters,inputs,analysis_type,sub_analysis_type);
 		[K_ff, K_fs] = Reducematrixfromgtof( K_gg, m.Gmn, m.nodesets); 
 		varargout(1)={K_ff};
Index: issm/trunk/src/m/solutions/cielo/objectivefunctionC.m
===================================================================
--- issm/trunk/src/m/solutions/cielo/objectivefunctionC.m	(revision 464)
+++ issm/trunk/src/m/solutions/cielo/objectivefunctionC.m	(revision 465)
@@ -1,3 +1,3 @@
-function J =objectivefunctionC(search_scalar,m,inputs,p_g,u_g_obs,grad_g,n,analysis_type);
+function J =objectivefunctionC(search_scalar,m,inputs,p_g,u_g_obs,grad_g,n,analysis_type,sub_analysis_type);
         
 %recover some parameters
@@ -13,6 +13,6 @@
 
 %Run diagnostic with updated parameters.
-u_g=diagnostic_core_nonlinear(m,inputs,analysis_type);
+u_g=diagnostic_core_nonlinear(m,inputs,analysis_type,sub_analysis_type);
 
 %Compute misfit for this velocity field. 
-J=Misfit(m.elements,m.nodes,m.loads,m.materials,m.parameters, u_g, u_g_obs,inputs);
+J=Misfit(m.elements,m.nodes,m.loads,m.materials,m.parameters, u_g, u_g_obs,inputs,analysis_type,sub_analysis_type);
Index: issm/trunk/src/m/solutions/cielo/thermal.m
===================================================================
--- issm/trunk/src/m/solutions/cielo/thermal.m	(revision 464)
+++ issm/trunk/src/m/solutions/cielo/thermal.m	(revision 465)
@@ -7,33 +7,32 @@
 	%timing
 	t1=clock;
-	
-	%md.analysis_type is set to thermalsteady or thermaltransient. save it.
-	solutiontype=md.analysis_type;
 
-	%Build all models requested for thermal and melting  simulation
-	md.analysis_type=solutiontype; m_t=CreateFemModel(md); 
-	md.analysis_type='melting' m_m=CreateFEMModel(md);
+	%Build all models requested for diagnostic simulation
+	displaystring(md.debug,'%s',['reading thermal model data']);
+	md.analysis_type='thermal'; m_t=CreateFemModel(md);
+
+	displaystring(md.debug,'%s',['reading melting model data']);
+	md.analysis_type='melting'; m_m=CreateFemModel(md);
 
 	% figure out number of dof: just for information purposes.
-	md.dof=m_t.nodesets.fsize; %biggest dof number
+	md.dof=m_t.nodesets.fsize;
 
-
-	if strcmpi(solutiontype,'thermalsteady'),
-
-		%initialize velocity and pressure 
-		u_g=m_t.parameters.u_g;
-		p_g=m_t.parameters.p_g;
-
-		inputs=struct('pressure',p_g,'velocity',u_g);
-
-		disp(sprintf('\n%s\n','computing temperature...'));
-		[t_g,m_t]=thermal_core(m_t,inputs);
-
-		disp(sprintf('\n%s\n','computing melting...'));
-		inputs=struct('pressure',p_g,'temperature',t_g);
+	%initialize inputs
+	displaystring(debug,'\n%s',['setup inputs...']);
+	inputs=inputlist;
+	inputs=add(inputs,'velocity',m_t.parameters.u_g,'doublevec',3,m_t.parameters.numberofnodes);
+	inputs=add(inputs,'pressure',m_t.parameters.p_g,'doublevec',1,m_t.parameters.numberofnodes);
+	inputs=add(inputs,'dt',m_t.parameters.dt,'double');
+	
+	if strcmpi(md.sub_analysis_type,'steady'),
+	
+		displaystring(debug,'\n%s',['computing temperatures...']);
+		[t_g loads_t melting_offset]=thermal_core(m_t,inputs,'thermal','steady');
 		
-		melting_g=melting_core(m_m,inputs);
-
-		%load results onto model
+		displaystring(debug,'\n%s',['computing melting...']);
+		inputs=add(inputs,'melting_offset',melting_offset,'double');
+		melting_g=melting_core(m_m,inputs,'melting','steady');
+		
+		displaystring(debug,'\n%s',['load results...']);
 		md.temperature=t_g;
 		md.melting=melting_g*md.yts; %from m/s to m/a
@@ -41,9 +40,9 @@
 	else
 
-		%initialize velocity, pressure  and temperature
-		u_g=m.parameters.u_g;
-		p_g=m.parameters.p_g;
-		t_g=m.parameters.t_g;
-		melting_g=m.parameters.melting_g;
+		%initialize velocity, pressure, temperature and melting
+		u_g=m_t.parameters.u_g;
+		p_g=m_t.parameters.p_g;
+		t_g=m_t.parameters.t_g;
+		melting_g=m_t.parameters.melting_g;
 
 		nsteps=m_t.parameters.ndt/m_t.parameters.dt;
@@ -55,9 +54,9 @@
 		for n=1:nsteps, 
 
-			disp(sprintf('\n%s%i/%i\n','time step: ',n,md.ndt/md.dt));
-			disp('   computing temperature...');
-		
-			inputs=struct('pressure',p_g,'temperature',soln(n).t_g,'velocity',u_g,'dt',m_t.parameters.dt);
-			[soln(n+1).t_g,m_t]=thermal_core(m_t,inputs);
+			displaystring(debug,'\n%s%i/%i\n','time step: ',n,nsteps);
+			
+			displaystring(debug,'\n%s',['    computing temperatures...']);
+			inputs=add(inputs,'temperature',soln(n).t_g,'doublevec',1,m_t.parameters.numberofnodes);
+			[soln(n+1).t_g loads_t melting_offset]=thermal_core(m_t,inputs);
 			
 			disp('   computing melting...');
@@ -80,3 +79,6 @@
 		md.melting=solution_melting;
 	end
-	
+
+	%stop timing
+	t2=clock;
+	displaystring(md.debug,'\n%s\n',['solution converged in ' num2str(etime(t2,t1)) ' seconds']);	
Index: issm/trunk/src/mex/ControlOptimization/ControlOptimization.cpp
===================================================================
--- issm/trunk/src/mex/ControlOptimization/ControlOptimization.cpp	(revision 464)
+++ issm/trunk/src/mex/ControlOptimization/ControlOptimization.cpp	(revision 465)
@@ -51,4 +51,5 @@
 	optargs.n=STEP;
 	optargs.analysis_type=ANALYSIS;
+	optargs.sub_analysis_type=SUBANALYSIS;
 
 	optpars.xmin=xmin;
@@ -73,5 +74,5 @@
 {
 	_printf_("\n");
-	_printf_("   usage: [search_scalar J] = %s(function_name,xmin,xmax,options,m,inputs,p_g,u_g_obs,grad_g,step,analysis_type)\n",__FUNCT__);
+	_printf_("   usage: [search_scalar J] = %s(function_name,xmin,xmax,options,m,inputs,p_g,u_g_obs,grad_g,step,analysis_type,sub_analysis_type)\n",__FUNCT__);
 	_printf_("\n");
 }
Index: issm/trunk/src/mex/ControlOptimization/ControlOptimization.h
===================================================================
--- issm/trunk/src/mex/ControlOptimization/ControlOptimization.h	(revision 464)
+++ issm/trunk/src/mex/ControlOptimization/ControlOptimization.h	(revision 465)
@@ -28,4 +28,5 @@
 #define STEP (mxArray*)prhs[9]
 #define ANALYSIS (mxArray*)prhs[10]
+#define SUBANALYSIS (mxArray*)prhs[11]
 
 /* serial output macros: */
@@ -37,5 +38,5 @@
 #define NLHS  2
 #undef NRHS
-#define NRHS  11
+#define NRHS  12
 
 
Index: issm/trunk/src/mex/Du/Du.cpp
===================================================================
--- issm/trunk/src/mex/Du/Du.cpp	(revision 464)
+++ issm/trunk/src/mex/Du/Du.cpp	(revision 465)
@@ -15,8 +15,11 @@
 	DataSet* loads=NULL;
 	DataSet* materials=NULL;
-	int      analysis_type;
 	double*  u_g=NULL;
 	double*  u_g_obs=NULL;
 	ParameterInputs* inputs=NULL;
+	char*             analysis_type_string=NULL;
+	int               analysis_type;
+	char*             sub_analysis_type_string=NULL;
+	int               sub_analysis_type;
 
 	/* output datasets: */
@@ -35,7 +38,10 @@
 	FetchData((void**)&loads,NULL,NULL,LOADS,"DataSet",NULL);
 	FetchData((void**)&materials,NULL,NULL,MATERIALS,"DataSet",NULL);
-	FetchData((void**)&analysis_type,NULL,NULL,mxGetField(PARAMETERS,0,"analysis_type"),"Integer",NULL);
 	FetchData((void**)&u_g,NULL,NULL,UG,"Vector","Vec");
 	FetchData((void**)&u_g_obs,NULL,NULL,UGOBS,"Vector","Vec");
+	FetchData((void**)&analysis_type_string,NULL,NULL,ANALYSIS,"String",NULL);
+	analysis_type=AnalysisTypeAsEnum(analysis_type_string);
+	FetchData((void**)&sub_analysis_type_string,NULL,NULL,SUBANALYSIS,"String",NULL);
+	sub_analysis_type=AnalysisTypeAsEnum(sub_analysis_type_string);
 
 	/*Fetch inputs: */
@@ -44,5 +50,5 @@
 
 	/*!Call core code: */
-	Dux(&du_g, elements,nodes,loads,materials,u_g,u_g_obs,inputs,analysis_type);
+	Dux(&du_g, elements,nodes,loads,materials,u_g,u_g_obs,inputs,analysis_type,sub_analysis_type);
 
 	/*write output : */
@@ -58,4 +64,6 @@
 	VecFree(&du_g);
 	delete inputs;
+	xfree((void**)&analysis_type_string);
+	xfree((void**)&sub_analysis_type_string);
 
 	/*end module: */
Index: issm/trunk/src/mex/Du/Du.h
===================================================================
--- issm/trunk/src/mex/Du/Du.h	(revision 464)
+++ issm/trunk/src/mex/Du/Du.h	(revision 465)
@@ -25,4 +25,6 @@
 #define UGOBS (mxArray*)prhs[6]
 #define INPUTS (mxArray*)prhs[7]
+#define ANALYSIS (mxArray*)prhs[8]
+#define SUBANALYSIS (mxArray*)prhs[9]
 
 /* serial output macros: */
@@ -33,5 +35,5 @@
 #define NLHS  1
 #undef NRHS
-#define NRHS  8
+#define NRHS  10
 
 
Index: issm/trunk/src/mex/Gradj/Gradj.cpp
===================================================================
--- issm/trunk/src/mex/Gradj/Gradj.cpp	(revision 464)
+++ issm/trunk/src/mex/Gradj/Gradj.cpp	(revision 465)
@@ -15,9 +15,12 @@
 	DataSet* loads=NULL;
 	DataSet* materials=NULL;
-	int      analysis_type;
 	char*    control_type=NULL;
 	double*  u_g=NULL;
 	double*  lambda_g=NULL;
 	ParameterInputs* inputs=NULL;
+	char*             analysis_type_string=NULL;
+	int               analysis_type;
+	char*             sub_analysis_type_string=NULL;
+	int               sub_analysis_type;
 
 	/* output datasets: */
@@ -36,8 +39,11 @@
 	FetchData((void**)&loads,NULL,NULL,LOADS,"DataSet",NULL);
 	FetchData((void**)&materials,NULL,NULL,MATERIALS,"DataSet",NULL);
-	FetchData((void**)&analysis_type,NULL,NULL,mxGetField(PARAMETERS,0,"analysis_type"),"Integer",NULL);
 	FetchData((void**)&control_type,NULL,NULL,mxGetField(PARAMETERS,0,"control_type"),"String",NULL);
 	FetchData((void**)&u_g,NULL,NULL,UG,"Vector","Vec");
 	FetchData((void**)&lambda_g,NULL,NULL,LAMBDAG,"Vector","Vec");
+	FetchData((void**)&analysis_type_string,NULL,NULL,ANALYSIS,"String",NULL);
+	analysis_type=AnalysisTypeAsEnum(analysis_type_string);
+	FetchData((void**)&sub_analysis_type_string,NULL,NULL,SUBANALYSIS,"String",NULL);
+	sub_analysis_type=AnalysisTypeAsEnum(sub_analysis_type_string);
 
 	/*Fetch inputs: */
@@ -46,5 +52,5 @@
 
 	/*!Call core code: */
-	Gradjx(&grad_g, elements,nodes,loads,materials,u_g,lambda_g,inputs,analysis_type,control_type);
+	Gradjx(&grad_g, elements,nodes,loads,materials,u_g,lambda_g,inputs,analysis_type,sub_analysis_type,control_type);
 
 	/*write output : */
@@ -61,4 +67,6 @@
 	delete inputs;
 	VecFree(&grad_g);
+	xfree((void**)&analysis_type_string);
+	xfree((void**)&sub_analysis_type_string);
 
 	/*end module: */
Index: issm/trunk/src/mex/Gradj/Gradj.h
===================================================================
--- issm/trunk/src/mex/Gradj/Gradj.h	(revision 464)
+++ issm/trunk/src/mex/Gradj/Gradj.h	(revision 465)
@@ -25,4 +25,6 @@
 #define LAMBDAG (mxArray*)prhs[6]
 #define INPUTS (mxArray*)prhs[7]
+#define ANALYSIS (mxArray*)prhs[8]
+#define SUBANALYSIS (mxArray*)prhs[9]
 
 /* serial output macros: */
@@ -33,5 +35,5 @@
 #define NLHS  1
 #undef NRHS
-#define NRHS  8
+#define NRHS  10
 
 
